// Generated by CoffeeScript 1.10.0
var EventEmitter, conditions, domain, each, registry, string, todos_create, todos_reset, wrap,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

module.exports = function() {
  var _run_, afters, befores, call_callback, depth, domain_on_error, enrich_options, handle_multiple_call, handler, headers, j, jump_to_error, killed, len, name, normalize_options, obj, once, option, properties, proto, ref, ref1, run, stack, store, todos;
  if (arguments.length === 2) {
    obj = arguments[0];
    obj.options = arguments[1];
  } else if (arguments.length === 1) {
    obj = new EventEmitter;
    obj.options = arguments[0];
  } else {
    obj = new EventEmitter;
    obj.options = {};
  }
  if (obj.registry == null) {
    obj.registry = {};
  }
  if (obj.propagated_options == null) {
    obj.propagated_options = [];
  }
  ref = module.exports.propagated_options;
  for (j = 0, len = ref.length; j < len; j++) {
    option = ref[j];
    obj.propagated_options.push(option);
  }
  store = {};
  properties = {};
  stack = [];
  todos = todos_create();
  befores = [];
  afters = [];
  depth = 0;
  headers = [];
  once = {};
  killed = false;
  if (obj.options.domain === true) {
    obj.options.domain = domain.create();
  }
  domain_on_error = function(err) {
    err.message = "Invalid State Error [" + err.message + "]";
    return handle_multiple_call(err);
  };
  if ((ref1 = obj.options.domain) != null) {
    ref1.on('error', domain_on_error);
  }
  normalize_options = function(_arguments, type, enrich) {
    var a, arg, callback, cloned_arg, empty, handler, i, k, l, len1, len2, len3, len4, m, n, o, options, opts, ref2, v;
    if (enrich == null) {
      enrich = true;
    }
    empty = false;
    handler = null;
    callback = null;
    options = [];
    for (l = 0, len1 = _arguments.length; l < len1; l++) {
      arg = _arguments[l];
      if (typeof arg === 'function') {
        if (!handler) {
          handler = arg;
        } else if (!callback) {
          callback = arg;
        } else {
          throw Error("Invalid third function argument");
        }
      } else if (Array.isArray(arg)) {
        if (arg.length === 0) {
          empty = true;
        }
        for (m = 0, len2 = arg.length; m < len2; m++) {
          a = arg[m];
          if (type === 'call') {
            if (!(typeof a === 'object' && !Array.isArray(a) && a !== null)) {
              a = {
                handler: a
              };
            }
          } else {
            if (!(typeof a === 'object' && !Array.isArray(a) && a !== null)) {
              a = {
                argument: a
              };
            }
          }
          options.push(a);
        }
      } else {
        if (typeof arg !== 'object' && arg !== null) {
          if (type === 'call') {
            arg = {
              handler: arg
            };
          } else {
            arg = {
              argument: arg
            };
          }
        }
        if (options.length === 0) {
          cloned_arg = {};
          for (k in arg) {
            v = arg[k];
            cloned_arg[k] = v;
          }
          options.push(cloned_arg);
        } else {
          for (n = 0, len3 = options.length; n < len3; n++) {
            opts = options[n];
            for (k in arg) {
              v = arg[k];
              opts[k] = v;
            }
          }
        }
      }
    }
    if (options.length === 0 && empty) {
      return options;
    }
    if (options.length === 0) {
      options.push({});
    }
    if (options.length && options.filter(function(opts) {
      return !opts.handler;
    }).length === 0) {
      callback = handler;
      handler = null;
    }
    for (i = o = 0, len4 = options.length; o < len4; i = ++o) {
      opts = options[i];
      options[i] = {};
      for (k in opts) {
        v = opts[k];
        options[i][k] = v;
      }
      opts = options[i];
      if (type) {
        opts.type = type;
      }
      if (handler) {
        if (opts.handler == null) {
          opts.handler = handler;
        }
      }
      if (callback) {
        if (opts.callback == null) {
          opts.callback = callback;
        }
      }
      if (enrich && ((ref2 = opts.callback) != null ? ref2.length : void 0) > 2) {
        opts.user_args = true;
      }
      if (enrich && store) {
        if (opts.store == null) {
          opts.store = store;
        }
      }
      if (opts.once === true) {
        opts.once = ['handler'];
      }
      if (opts.once === false) {
        delete opts.once;
      }
      if (Array.isArray(opts.once)) {
        opts.once = opts.once.sort();
      }
      if (opts.wait == null) {
        opts.wait = 3000;
      }
      if (!(typeof opts.wait === 'number' && opts.wait >= 0)) {
        jump_to_error(Error("Invalid options wait, got " + (JSON.stringify(opts.wait))));
      }
    }
    return options;
  };
  enrich_options = function(user_options) {
    var _logs, global_options, k, options, parent_options, ref2, v;
    user_options.enriched = true;
    global_options = obj.options;
    parent_options = todos.options;
    options = {};
    for (k in user_options) {
      v = user_options[k];
      options[k] = user_options[k];
    }
    for (k in parent_options) {
      v = parent_options[k];
      if (options[k] === void 0 && indexOf.call(obj.propagated_options, k) >= 0) {
        options[k] = v;
      }
    }
    for (k in global_options) {
      v = global_options[k];
      if (options[k] === void 0) {
        options[k] = v;
      }
    }
    if (!((ref2 = options.log) != null ? ref2.dont : void 0)) {
      if (options.log && !Array.isArray(options.log)) {
        _logs = [options.log];
      } else if (!options.log) {
        _logs = [];
      }
    }
    if (options.log == null) {
      options.log = [];
    }
    if (!Array.isArray(options.log)) {
      options.log = [options.log];
    }
    _logs = options.log;
    if (options.debug) {
      _logs.push(function(log) {
        var msg, ref3, ref4;
        if ((ref3 = log.type) === 'stdout' || ref3 === 'stderr') {
          return;
        }
        msg = ((ref4 = log.message) != null ? ref4.toString : void 0) != null ? log.message.toString() : log.message;
        msg = "[" + log.total_depth + "." + log.level + " " + log.module + "] " + (JSON.stringify(msg));
        msg = (function() {
          switch (log.type) {
            case 'stdout_stream':
              return "\x1b[36m" + msg + "\x1b[39m";
            case 'stderr_stream':
              return "\x1b[35m" + msg + "\x1b[39m";
            default:
              return "\x1b[32m" + msg + "\x1b[39m";
          }
        })();
        return process.stdout.write(msg + "\n");
      });
    }
    options.log = function(log) {
      var _log, args, file, frame, header, l, len1, len2, line, m, method, path, stackTrace;
      if (typeof log === 'string') {
        log = {
          message: log
        };
      }
      if (log.level == null) {
        log.level = 'INFO';
      }
      if (log.time == null) {
        log.time = Date.now();
      }
      if (log.module == null) {
        log.module = void 0;
      }
      if (log.header_depth == null) {
        log.header_depth = depth;
      }
      for (l = 0, len1 = headers.length; l < len1; l++) {
        header = headers[l];
        if (log.headers == null) {
          log.headers = header;
        }
      }
      if (log.total_depth == null) {
        log.total_depth = stack.length;
      }
      if (log.type == null) {
        log.type = 'text';
      }
      args = 1 <= arguments.length ? [].slice.call(arguments, 0) : [];
      stackTrace = require('stack-trace');
      path = require('path');
      frame = stackTrace.get()[1];
      file = path.basename(frame.getFileName());
      line = frame.getLineNumber();
      method = frame.getFunctionName();
      log.file = file;
      log.line = line;
      args.unshift("" + file + ":" + line + " in " + method + "()");
      for (m = 0, len2 = _logs.length; m < len2; m++) {
        _log = _logs[m];
        _log(log);
      }
      return typeof obj.emit === "function" ? obj.emit(log.type, log) : void 0;
    };
    return options;
  };
  call_callback = function(fn, args) {
    var err, error, mtodos;
    stack.unshift(todos);
    todos = todos_create();
    try {
      fn.apply(obj, args);
    } catch (error) {
      err = error;
      todos = stack.shift();
      jump_to_error(err);
      args[0] = err;
      return run();
    }
    mtodos = todos;
    todos = stack.shift();
    if (mtodos.length) {
      return todos.unshift.apply(todos, mtodos);
    }
  };
  handle_multiple_call = function(err) {
    killed = true;
    while (stack.length) {
      todos = stack.shift();
    }
    jump_to_error(err);
    return run();
  };
  jump_to_error = function(err) {
    while (todos[0] && todos[0].type !== 'then') {
      todos.shift();
    }
    return todos.err = err;
  };
  _run_ = function() {
    if (obj.options.domain) {
      return obj.options.domain.run(run);
    } else {
      return run();
    }
  };
  run = function(options, callback) {
    var err, header, org_options, ref2, ref3, status;
    if (!options) {
      options = todos.shift();
    }
    if (!options) {
      if (stack.length === 0) {
        if ((ref2 = obj.options.domain) != null) {
          ref2.removeListener('error', domain_on_error);
        }
      }
      if (callback) {
        callback(todos.err);
      } else {
        if (stack.length === 0 && todos.err && todos.throw_if_error) {
          throw todos.err;
        }
      }
      return;
    }
    org_options = options;
    options = enrich_options(options);
    if (options.type === 'then') {
      err = todos.err, status = todos.status;
      status = status.some(function(status) {
        return !status.shy && !!status.value;
      });
      todos_reset(todos);
      if ((ref3 = options.handler) != null) {
        ref3.call(obj, err, status);
      }
      run();
      return;
    }
    if (killed) {
      return;
    }
    if (options.type === 'end') {
      return conditions.all(obj, options, function(err) {
        if (callback) {
          callback(err);
        }
        return run();
      }, function() {
        while (todos[0] && todos[0].type !== 'then') {
          todos.shift();
        }
        if (callback) {
          callback(err);
        }
        return run();
      });
    }
    if (options.header) {
      depth++;
    }
    if (options.header) {
      headers.push(options.header);
    }
    if (options.header) {
      options.log({
        message: options.header,
        type: 'header',
        depth: depth,
        headers: (function() {
          var l, len1, results;
          results = [];
          for (l = 0, len1 = headers.length; l < len1; l++) {
            header = headers[l];
            results.push(header);
          }
          return results;
        })()
      });
    }
    todos.status.unshift({
      shy: options.shy,
      value: void 0
    });
    stack.unshift(todos);
    todos = todos_create();
    todos.options = org_options;
    return wrap.options(options, function(err) {
      var copy, do_callback, do_conditions, do_handler, do_intercept_after, do_intercept_before, do_once, k, v;
      copy = {};
      for (k in options) {
        v = options[k];
        copy[k] = v;
      }
      options = copy;
      do_once = function() {
        var hash, hashme;
        hashme = function(value) {
          if (typeof value === 'string') {
            value = "string:" + (string.hash(value));
          } else if (typeof value === 'boolean') {
            value = "boolean:" + value;
          } else if (typeof value === 'boolean') {
            value = "boolean:" + value;
          } else if (typeof value === 'function') {
            value = "function:" + (string.hash(value.toString()));
          } else if (value === void 0 || value === null) {
            value = 'null';
          } else if (Array.isArray(value)) {
            value = 'array:' + value.sort().map(function(value) {
              return hashme(value);
            }).join(':');
          } else if (typeof value === 'object') {
            value = 'object';
          } else {
            throw Error("Invalid data type: " + (JSON.stringify(value)));
          }
          return value;
        };
        if (options.once) {
          if (typeof options.once === 'string') {
            hash = string.hash(options.once);
          } else if (Array.isArray(options.once)) {
            hash = string.hash(options.once.map(function(k) {
              return hashme(options[k]);
            }).join('|'));
          } else {
            throw Error("Invalid Type Option Once: " + (JSON.stringify(options.once)));
          }
          if (once[hash]) {
            return do_callback([]);
          }
          once[hash] = true;
        }
        return do_intercept_before();
      };
      do_intercept_before = function() {
        if (options.intercept_before) {
          return do_conditions();
        }
        return each(befores).call(function(before, next) {
          var opts;
          for (k in before) {
            v = before[k];
            if (k === 'handler') {
              continue;
            }
            if (v !== options[k]) {
              return next();
            }
          }
          opts = {
            intercept_before: true
          };
          for (k in before) {
            v = before[k];
            opts[k] = v;
          }
          for (k in options) {
            v = options[k];
            if (k === 'handler' || k === 'callback') {
              continue;
            }
            if (opts[k] == null) {
              opts[k] = v;
            }
          }
          return run(opts, next);
        }).error(function(err) {
          return do_callback([err]);
        }).then(do_conditions);
      };
      do_conditions = function() {
        return conditions.all(obj, options, function(err) {
          return do_callback([err]);
        }, function() {
          for (k in options) {
            v = options[k];
            if (/^if.*/.test(k) || /^unless.*/.test(k)) {
              delete options[k];
            }
          }
          return do_handler();
        });
      };
      options.attempt = -1;
      do_handler = function() {
        var called, do_next, error, options_callback, options_handler, status_sync, wait_children;
        options.attempt++;
        do_next = function(arg1) {
          var err;
          err = arg1[0];
          options.handler = options_handler;
          options.callback = options_callback;
          if (err) {
            options.log({
              message: err.message,
              level: 'ERROR',
              module: 'mecano'
            });
          }
          if (err && options.attempt < options.retry - 1) {
            options.log({
              message: "Retry on error, attempt " + (options.attempt + 1),
              level: 'WARN',
              module: 'mecano'
            });
            return setTimeout(do_handler, options.wait);
          }
          return do_intercept_after.apply(null, arguments);
        };
        options_handler = options.handler;
        options.handler = void 0;
        options_callback = options.callback;
        options.callback = void 0;
        called = false;
        try {
          if (options_handler.length === 2) {
            return options_handler.call(obj, options, function() {
              var args;
              if (killed) {
                return;
              }
              if (called) {
                return handle_multiple_call(Error('Multiple call detected'));
              }
              called = true;
              args = [].slice.call(arguments, 0);
              return setImmediate(function() {
                return do_next(args);
              });
            });
          } else {
            options_handler.call(obj, options);
            if (killed) {
              return;
            }
            if (called) {
              return handle_multiple_call(Error('Multiple call detected'));
            }
            called = true;
            status_sync = false;
            wait_children = function() {
              var loptions;
              if (!todos.length) {
                return setImmediate(function() {
                  return do_next([null, status_sync]);
                });
              }
              loptions = todos.shift();
              return run(loptions, function(err, status) {
                if (err) {
                  return do_next([err]);
                }
                if (status && !loptions.shy) {
                  status_sync = true;
                }
                return wait_children();
              });
            };
            return wait_children();
          }
        } catch (error) {
          err = error;
          todos = [];
          return do_next([err]);
        }
      };
      do_intercept_after = function(args, callback) {
        if (options.intercept_after) {
          return do_callback(args);
        }
        return each(afters).call(function(after, next) {
          var opts;
          for (k in after) {
            v = after[k];
            if (k === 'handler') {
              continue;
            }
            if (v !== options[k]) {
              return next();
            }
          }
          opts = {
            intercept_after: true
          };
          for (k in after) {
            v = after[k];
            opts[k] = v;
          }
          for (k in options) {
            v = options[k];
            if (k === 'handler' || k === 'callback') {
              continue;
            }
            if (opts[k] == null) {
              opts[k] = v;
            }
          }
          opts.callback_arguments = args;
          return run(opts, next);
        }).error(function(err) {
          return do_callback([err]);
        }).then(function() {
          return do_callback(args);
        });
      };
      do_callback = function(args) {
        if (killed) {
          return;
        }
        if (!args[0]) {
          args[0] = void 0;
        }
        args[1] = !!args[1];
        if (todos.length === 0) {
          todos = stack.shift();
        }
        if (args[0] && !options.relax) {
          jump_to_error(args[0]);
        }
        if (args[0] && options.callback) {
          todos.throw_if_error = false;
        }
        todos.status[0].value = args[1];
        if (options.callback) {
          call_callback(options.callback, args);
        }
        if (options.relax) {
          args[0] = null;
        }
        if (options.header) {
          depth--;
        }
        if (options.header) {
          headers.pop();
        }
        if (callback) {
          callback(args[0], args[1]);
        }
        return run();
      };
      return do_once();
    });
  };
  properties.child = {
    get: function() {
      return function() {
        return module.exports(obj.options);
      };
    }
  };
  properties.then = {
    get: function() {
      return function() {
        todos.push({
          type: 'then',
          handler: arguments[0]
        });
        if (todos.length === 1) {
          setImmediate(_run_);
        }
        return obj;
      };
    }
  };
  properties.end = {
    get: function() {
      return function() {
        var args, l, len1, options, opts;
        args = [].slice.call(arguments);
        options = normalize_options(args, 'end');
        for (l = 0, len1 = options.length; l < len1; l++) {
          opts = options[l];
          todos.push(opts);
        }
        if (todos.length === options.length) {
          setImmediate(_run_);
        }
        return obj;
      };
    }
  };
  properties.call = {
    get: function() {
      return function() {
        var args, k, l, len1, len2, m, mod, options, opts, ref2, v;
        args = [].slice.call(arguments);
        options = normalize_options(args, 'call');
        for (l = 0, len1 = options.length; l < len1; l++) {
          opts = options[l];
          if (typeof opts.handler === 'string') {
            mod = require.main.require(opts.handler);
            if (Array.isArray(mod)) {
              throw Error('Array modules not yet supported');
            }
            mod = normalize_options([mod], 'call');
            opts.handler = mod.handler;
            ref2 = mod[0];
            for (k in ref2) {
              v = ref2[k];
              if (opts[k] == null) {
                opts[k] = v;
              }
            }
          }
          if (!opts.handler) {
            throw Error('Missing handler option');
          }
          if (typeof opts.handler !== 'function') {
            throw Error("Handler not a function, got '" + opts.handler + "'");
          }
        }
        for (m = 0, len2 = options.length; m < len2; m++) {
          opts = options[m];
          todos.push(opts);
        }
        if (todos.length === options.length) {
          setImmediate(_run_);
        }
        return obj;
      };
    }
  };
  properties.before = {
    get: function() {
      return function() {
        var l, len1, options, opts;
        if (typeof arguments[0] === 'string') {
          arguments[0] = {
            type: arguments[0]
          };
        }
        options = normalize_options(arguments, null, false);
        for (l = 0, len1 = options.length; l < len1; l++) {
          opts = options[l];
          if (typeof opts.handler !== 'function') {
            throw Error("Invalid handler " + (JSON.stringify(opts.handler)));
          }
          befores.push(opts);
        }
        return obj;
      };
    }
  };
  properties.after = {
    get: function() {
      return function() {
        var l, len1, options, opts;
        if (typeof arguments[0] === 'string') {
          arguments[0] = {
            type: arguments[0]
          };
        }
        options = normalize_options(arguments, null, false);
        for (l = 0, len1 = options.length; l < len1; l++) {
          opts = options[l];
          if (typeof opts.handler !== 'function') {
            throw Error("Invalid handler " + (JSON.stringify(opts.handler)));
          }
          afters.push(opts);
        }
        return obj;
      };
    }
  };
  properties.status = {
    get: function() {
      return function(index) {
        var l, len1, len2, m, ref2, ref3, ref4, status, value;
        if (arguments.length === 0) {
          return stack[0].status.some(function(status) {
            return !status.shy && !!status.value;
          });
        } else if (index === false) {
          value = stack[0].status.some(function(status) {
            return !status.shy && !!status.value;
          });
          ref2 = stack[0].status;
          for (l = 0, len1 = ref2.length; l < len1; l++) {
            status = ref2[l];
            status.value = false;
          }
          return value;
        } else if (index === true) {
          value = stack[0].status.some(function(status) {
            return !status.shy && !!status.value;
          });
          ref3 = stack[0].status;
          for (m = 0, len2 = ref3.length; m < len2; m++) {
            status = ref3[m];
            status.value = true;
          }
          return value;
        } else {
          return (ref4 = stack[0].status[Math.abs(index)]) != null ? ref4.value : void 0;
        }
      };
    }
  };
  proto = Object.defineProperties(obj, properties);
  Object.defineProperty(obj, 'unregister', {
    get: function() {
      return function(name, handler) {
        if (obj.registered(name, true)) {
          delete obj.registry[name];
          delete obj[name];
        }
        return obj;
      };
    }
  });
  Object.defineProperty(obj, 'register', {
    get: function() {
      return function(name, handler) {
        if (!handler) {
          return obj.unregister(name);
        }
        if (typeof handler === 'string') {
          handler = require.main.require(handler);
        }
        obj.registry[name] = handler;
        return Object.defineProperty(obj, name, {
          configurable: true,
          get: function() {
            return function() {
              var args, l, len1, options, opts;
              args = [].slice.call(arguments);
              args.unshift(obj.registry[name]);
              options = normalize_options(args, name);
              for (l = 0, len1 = options.length; l < len1; l++) {
                opts = options[l];
                todos.push(opts);
              }
              if (todos.length === options.length) {
                setImmediate(_run_);
              }
              return obj;
            };
          }
        });
      };
    }
  });
  Object.defineProperty(obj, 'registered', {
    get: function() {
      return function(name, local_only) {
        var global, local;
        if (local_only == null) {
          local_only = false;
        }
        global = Object.prototype.hasOwnProperty.call(module.exports, name);
        local = Object.prototype.hasOwnProperty.call(obj, name);
        if (local_only) {
          return local;
        } else {
          return global || local;
        }
      };
    }
  });
  for (name in registry) {
    handler = registry[name];
    obj.register(name, handler);
  }
  return obj;
};

module.exports.propagated_options = ['ssh', 'log', 'stdout', 'stderr', 'debug'];

todos_create = function() {
  var todos;
  todos = [];
  todos_reset(todos);
  return todos;
};

todos_reset = function(todos) {
  todos.err = null;
  todos.status = [];
  return todos.throw_if_error = true;
};

registry = require('./misc/registry');

domain = require('domain');

each = require('each');

conditions = require('./misc/conditions');

wrap = require('./misc/wrap');

string = require('./misc/string');

EventEmitter = require('events').EventEmitter;
