// Generated by CoffeeScript 1.10.0
var fs, misc;

module.exports = function(options, callback) {
  var do_chmod, do_stat;
  options.log({
    message: "Entering chmod",
    level: 'DEBUG',
    module: 'mecano/lib/chmod'
  });
  if (!options.destination) {
    return callback(Error("Missing destination: " + (JSON.stringify(options.destination))));
  }
  if (!options.mode) {
    return callback(Error("Missing option 'mode'"));
  }
  do_stat = function() {
    if (options.stat) {
      return do_chmod(options.stat);
    }
    options.log({
      message: "Stat \"" + options.destination + "\"",
      level: 'DEBUG',
      module: 'mecano/lib/chmod'
    });
    return fs.stat(options.ssh, options.destination, function(err, stat) {
      if (err) {
        return callback(err);
      }
      return do_chmod(stat);
    });
  };
  do_chmod = function(stat) {
    if (misc.mode.compare(stat.mode, options.mode)) {
      options.log({
        message: "Identical permissions on \"" + options.destination + "\"",
        level: 'INFO',
        module: 'mecano/lib/chmod'
      });
      return callback();
    }
    return fs.chmod(options.ssh, options.destination, options.mode, function(err) {
      options.log({
        message: "Change permissions from \"" + stat.mode + "\" to \"" + options.mode + "\" on \"" + options.destination + "\"",
        level: 'WARN',
        module: 'mecano/lib/chmod'
      });
      return callback(err, true);
    });
  };
  return do_stat();
};

fs = require('ssh2-fs');

misc = require('../misc');
