// Generated by CoffeeScript 1.10.0
var fs, path;

module.exports = function(options, callback) {
  var cmd, dir, ext, format, name;
  options.log({
    message: "Entering compress",
    level: 'DEBUG',
    module: 'mecano/lib/compress'
  });
  if (!options.source) {
    return callback(new Error("Missing source: " + options.source));
  }
  if (!options.destination) {
    return callback(new Error("Missing destination: " + options.destination));
  }
  options.source = path.normalize(options.source);
  options.destination = path.normalize(options.destination);
  dir = path.dirname(options.source);
  name = path.basename(options.source);
  if (options.format != null) {
    format = options.format;
  } else {
    if (/\.(tar\.gz|tgz)$/.test(options.destination)) {
      format = 'tgz';
    } else if (/\.tar$/.test(options.destination)) {
      format = 'tar';
    } else if (/\.zip$/.test(options.destination)) {
      format = 'zip';
    } else if (/\.bz2$/.test(options.destination)) {
      format = 'bz2';
    } else if (/\.xz$/.test(options.destination)) {
      format = 'xz';
    } else {
      ext = path.extname(options.source);
      return callback(Error("Unsupported extension, got " + (JSON.stringify(ext))));
    }
  }
  cmd = null;
  switch (format) {
    case 'tgz':
      cmd = "tar czf " + options.destination + " -C " + dir + " " + name;
      break;
    case 'tar':
      cmd = "tar cf  " + options.destination + " -C " + dir + " " + name;
      break;
    case 'bz2':
      cmd = "tar cjf " + options.destination + " -C " + dir + " " + name;
      break;
    case 'xz':
      cmd = "tar cJf " + options.destination + " -C " + dir + " " + name;
      break;
    case 'zip':
      cmd = "(cd " + dir + " && zip -r " + options.destination + " " + name + " && cd -)";
  }
  return this.execute({
    cmd: cmd
  }, function(err, created) {
    if (err) {
      return callback(err);
    }
    return fs.exists(options.ssh, options.destination, function(err, exists) {
      if (!exists) {
        return callback(new Error("Failed to create '" + options.destination + "'"));
      }
      return callback(null, true);
    });
  });
};

fs = require('ssh2-fs');

path = require('path');
