// Generated by CoffeeScript 1.10.0
module.exports = function(options, callback) {
  var i, j, len, len1, opt, ref, ref1, ref2, write;
  options.log({
    message: "Entering system_limits",
    level: 'DEBUG',
    module: 'mecano/lib/system_limits'
  });
  if (!options.user) {
    return callback(Error("Missing required option 'user'"));
  }
  ref = ['nofile', 'nproc'];
  for (i = 0, len = ref.length; i < len; i++) {
    opt = ref[i];
    if ((options[opt] != null) && ((ref1 = typeof options[opt]) !== 'boolean' && ref1 !== 'number')) {
      return callback(Error("Invalid option '" + opt + "'"));
    }
  }
  ref2 = ['as', 'core', 'cpu', 'data', 'fsize', 'locks', 'maxlogins', 'maxsyslogins', 'memlock', 'msgqueue', 'nice', 'priority', 'rss', 'sigpending', 'stack', 'rtprio'];
  for (j = 0, len1 = ref2.length; j < len1; j++) {
    opt = ref2[j];
    if ((options[opt] != null) && typeof options[opt] !== 'number') {
      return callback(Error("Invalid option '" + opt + "'"));
    }
  }
  if (options.destination == null) {
    options.destination = "/etc/security/limits.d/" + options.user + ".conf";
  }
  write = [];
  return this.execute({
    cmd: "cat /proc/sys/fs/file-max",
    shy: true,
    "if": options.nofile
  }, function(err, status, stdout) {
    var kern_limit;
    if (err) {
      throw err;
    }
    if (!status) {
      return;
    }
    kern_limit = parseInt(stdout.trim());
    if (options.nofile === true) {
      return options.nofile = Math.round(kern_limit * 0.75);
    } else {
      if (options.nofile >= kern_limit) {
        throw Error("Invalid nofile options. Please set int value lesser than kernel limit: " + kern_limit);
      }
    }
  }).execute({
    cmd: "cat /proc/sys/kernel/pid_max",
    shy: true,
    "if": options.nproc
  }, function(err, status, stdout) {
    var kern_limit;
    if (err) {
      throw err;
    }
    if (!status) {
      return;
    }
    kern_limit = parseInt(stdout.trim());
    if (options.nproc === true) {
      return options.nproc = Math.round(kern_limit * 0.75);
    } else {
      if (options.nproc >= kern_limit) {
        throw Error("Invalid nproc options. Please set int value lesser than kernel limit: " + kern_limit);
      }
    }
  }).call(function() {
    var k, len2, ref3;
    ref3 = ['as', 'core', 'cpu', 'data', 'fsize', 'locks', 'maxlogins', 'maxsyslogins', 'memlock', 'msgqueue', 'nice', 'nofile', 'nproc', 'priority', 'rss', 'sigpending', 'stack', 'rtprio'];
    for (k = 0, len2 = ref3.length; k < len2; k++) {
      opt = ref3[k];
      if (options[opt] != null) {
        write.push({
          match: RegExp("^" + options.user + ".+" + opt + ".+$", 'm'),
          replace: options.user + "    -    " + opt + "   " + options[opt],
          append: true
        });
      }
    }
    return false;
  }).write({
    destination: options.destination,
    write: write,
    eof: true,
    uid: options.uid,
    gid: options.gid,
    "if": function() {
      return write.length;
    }
  }).then(callback);
};
