// Generated by CoffeeScript 1.10.0
var file, fs, misc, path, ssh2fs;

module.exports = function(options) {
  var algo, destination_stat, ref, ref1, source_stat, stage_destination, status;
  options.log({
    message: "Entering upload",
    level: 'DEBUG',
    module: 'mecano/lib/upload'
  });
  if (!options.source) {
    throw Error("Required \"source\" option");
  }
  if (!options.destination) {
    throw Error("Required \"destination\" option");
  }
  options.log({
    message: "Source is \"" + options.source + "\"",
    level: 'DEBUG',
    module: 'mecano/lib/upload'
  });
  options.log({
    message: "Destination is \"" + options.destination + "\"",
    level: 'DEBUG',
    module: 'mecano/lib/upload'
  });
  status = false;
  source_stat = null;
  destination_stat = null;
  stage_destination = options.destination + "." + (Date.now()) + (Math.round(Math.random() * 1000));
  if (options.md5 != null) {
    if ((ref = typeof options.md5) !== 'string' && ref !== 'boolean') {
      return callback(new Error("Invalid MD5 Hash:" + options.md5));
    }
    algo = 'md5';
  } else if (options.sha1 != null) {
    if ((ref1 = typeof options.sha1) !== 'string' && ref1 !== 'boolean') {
      return callback(new Error("Invalid SHA-1 Hash:" + options.sha1));
    }
    algo = 'sha1';
  } else {
    algo = 'md5';
  }
  this.call(function(_, callback) {
    return ssh2fs.stat(options.ssh, options.source, function(err, stat) {
      if (err && err.code !== 'ENOENT') {
        callback(err);
      }
      source_stat = stat;
      return callback();
    });
  });
  this.call(function(_, callback) {
    return ssh2fs.stat(null, options.destination, function(err, stat) {
      if (err && err.code === 'ENOENT') {
        return callback();
      }
      if (err) {
        return callback(err);
      }
      if (stat.isFile()) {
        destination_stat = stat;
      }
      if (!stat.isDirectory()) {
        return callback();
      }
      options.destination = path.resolve(options.destination, path.basename(options.source));
      return ssh2fs.stat(null, options.destination, function(err, stat) {
        if (err && err.code === 'ENOENT') {
          return callback();
        }
        if (err) {
          return callback(err);
        }
        if (stat.isFile()) {
          destination_stat = stat;
        }
        if (stat.isFile()) {
          return callback();
        }
        return callback(Error("Invalid destination: " + options.destination));
      });
    });
  });
  this.call({
    handler: function(_, callback) {
      if (!destination_stat) {
        return callback(null, true);
      }
      return file.compare_hash(options.ssh, options.source, null, options.destination, algo, (function(_this) {
        return function(err, match) {
          return callback(err, !match);
        };
      })(this));
    }
  });
  this.mkdir({
    "if": function() {
      return this.status(-1);
    },
    ssh: null,
    destination: path.dirname(stage_destination)
  });
  this.call({
    "if": function() {
      return this.status(-2);
    },
    handler: function(_, callback) {
      return ssh2fs.createReadStream(options.ssh, options.source, (function(_this) {
        return function(err, rs) {
          var ws;
          if (err) {
            return callback(err);
          }
          ws = fs.createWriteStream(stage_destination);
          return rs.pipe(ws).on('close', callback).on('error', callback);
        };
      })(this));
    }
  });
  return this.call(function() {
    this.move({
      ssh: null,
      "if": this.status(),
      source: stage_destination,
      destination: options.destination
    }, function(err, status) {
      if (status) {
        return options.log({
          message: "Unstaged uploaded file",
          level: 'INFO',
          module: 'mecano/lib/upload'
        });
      }
    });
    this.chmod({
      ssh: null,
      destination: options.destination,
      mode: options.mode,
      "if": options.mode != null
    });
    return this.chown({
      ssh: null,
      destination: options.destination,
      uid: options.uid,
      gid: options.gid,
      "if": (options.uid != null) || (options.gid != null)
    });
  });
};

fs = require('fs');

ssh2fs = require('ssh2-fs');

path = require('path');

misc = require('../misc');

file = require('../misc/file');
