// Generated by CoffeeScript 1.10.0
var docker, path, ssh2fs;

module.exports = function(options) {
  var _, destination_container, destination_mkdir, destination_path, k, ref, ref1, ref2, source_container, source_mkdir, source_path, v;
  options.log({
    message: "Entering Docker cp",
    level: 'DEBUG',
    module: 'mecano/lib/docker/cp'
  });
  if (options.docker == null) {
    options.docker = {};
  }
  ref = options.docker;
  for (k in ref) {
    v = ref[k];
    if (options[k] == null) {
      options[k] = v;
    }
  }
  if (!options.source) {
    throw Error('Missing option "source"');
  }
  if (!options.destination) {
    throw Error('Missing option "destination"');
  }
  ref1 = /(.*:)?(.*)/.exec(options.source), _ = ref1[0], source_container = ref1[1], source_path = ref1[2];
  ref2 = /(.*:)?(.*)/.exec(options.destination), _ = ref2[0], destination_container = ref2[1], destination_path = ref2[2];
  if (source_container && destination_container) {
    throw Error('Incompatible source and destination options');
  }
  if (!source_container && !destination_container) {
    throw Error('Incompatible source and destination options');
  }
  source_mkdir = false;
  destination_mkdir = false;
  this.call(function(_, next) {
    if (source_container) {
      return next();
    }
    if (/\/$/.test(source_path)) {
      source_path = source_path + "/" + (path.basename(destination_path));
      return next();
    }
    return ssh2fs.stat(options.ssh, source_path, function(err, stat) {
      if (err && err.code !== 'ENOENT') {
        return next(err);
      }
      if ((err != null ? err.code : void 0) === 'ENOENT') {
        return destination_mkdir = true && next();
      }
      if (stat.isDirectory()) {
        source_path = source_path + "/" + (path.basename(destination_path));
      }
      return next();
    });
  });
  this.mkdir({
    destination: source_path,
    "if": function() {
      return source_mkdir;
    }
  });
  this.call(function(_, next) {
    if (destination_container) {
      return next();
    }
    if (/\/$/.test(destination_path)) {
      destination_path = destination_path + "/" + (path.basename(destination_path));
      return next();
    }
    return ssh2fs.stat(options.ssh, destination_path, function(err, stat) {
      if (err && err.code !== 'ENOENT') {
        return next(err);
      }
      if ((err != null ? err.code : void 0) === 'ENOENT') {
        return destination_mkdir = true && next();
      }
      if (stat.isDirectory()) {
        destination_path = destination_path + "/" + (path.basename(destination_path));
      }
      return next();
    });
  });
  this.mkdir({
    destination: destination_path,
    "if": function() {
      return destination_mkdir;
    }
  });
  return this.execute({
    cmd: docker.wrap(options, "cp " + options.source + " " + options.destination)
  }, docker.callback);
};

path = require('path');

ssh2fs = require('ssh2-fs');

docker = require('../misc/docker');
