// Generated by CoffeeScript 1.10.0
var docker, util;

module.exports = function(options) {
  var cmd, k, ref, v;
  options.log({
    message: "Entering Docker start",
    level: 'DEBUG',
    module: 'mecano/lib/docker/start'
  });
  if (options.docker == null) {
    options.docker = {};
  }
  ref = options.docker;
  for (k in ref) {
    v = ref[k];
    if (options[k] == null) {
      options[k] = v;
    }
  }
  if (options.container == null) {
    throw Error('Missing container parameter');
  }
  cmd = 'start';
  if (options.attach) {
    cmd += ' -a';
  }
  cmd += " " + options.container;
  this.docker_status({
    shy: true
  }, options, function(err, is_running) {
    if (err) {
      throw err;
    }
    if (is_running) {
      options.log({
        message: "Container already started " + options.container + " (Skipping)",
        level: 'INFO',
        module: 'mecano/lib/docker/start'
      });
    } else {
      options.log({
        message: "Starting container " + options.container,
        level: 'INFO',
        module: 'mecano/lib/docker/start'
      });
    }
    if (is_running) {
      return this.end();
    }
  });
  return this.execute({
    cmd: docker.wrap(options, cmd)
  }, docker.callback);
};

docker = require('../misc/docker');

util = require('util');
