// Generated by CoffeeScript 1.10.0
var each, ssh2fs;

module.exports = function(options, callback) {
  var modified;
  modified = false;
  if (options.destination == null) {
    return callback(Error("Missing destination: " + options.destination));
  }
  if (!Array.isArray(options.destination)) {
    options.destination = [options.destination];
  }
  if (options.interval == null) {
    options.interval = 2000;
  }
  options.log({
    message: "Entering wait for file",
    level: 'DEBUG',
    module: 'mecano/wait/exist'
  });
  modified = false;
  return each(options.destination).call((function(_this) {
    return function(destination, next) {
      var count, run;
      count = 0;
      run = function() {
        count++;
        options.log({
          message: "Attempt #" + count,
          level: 'INFO',
          module: 'mecano/wait/exist'
        });
        return ssh2fs.stat(options.ssh, destination, function(err, stat) {
          if (err && err.code !== 'ENOENT') {
            return next(err);
          }
          if (err) {
            return setTimeout(run, options.interval);
          }
          options.log({
            message: "Finish wait for file",
            level: 'INFO',
            module: 'mecano/wait/exist'
          });
          if (count > 1) {
            modified = true;
          }
          return next();
        });
      };
      return run();
    };
  })(this)).then(function(err) {
    return callback(err, modified);
  });
};

each = require('each');

ssh2fs = require('ssh2-fs');
